---------------------------------------------------------------------------
--
-- Copyright (c) 2016
-- Mitsubishi Electric Corporation
-- All rights reserved.
-- 
-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are
-- met:
-- 
-- 1. Redistributions of source code must retain the above copyright
-- notice, this list of conditions and the following disclaimer.
-- 
-- 2. Redistributions in binary form must reproduce the above copyright
-- notice, this list of conditions and the following disclaimer in the
-- documentation and/or other materials provided with the distribution.
-- 
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-- LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-- DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-- THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-- (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-- OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--
-- File Name: MA_Sbox.vhd
-- Type: RTL 
-- Author: Takeshi SUGAWARA
-- Date: 2016/05/26
-- Version: 1.0
-- Abstract:
-- Modification History: 
--
---------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;  

entity MA_Sbox is
  port(
    x: in  std_logic_vector(3 downto 0);
    y: out std_logic_vector(3 downto 0)
    );
end MA_Sbox;

architecture RTL of MA_Sbox is
  
begin
  sbox_decoder: process(x)
  begin
    case x is
      when x"0" =>   y <= x"b";
      when x"1" =>   y <= x"3";
      when x"2" =>   y <= x"4";
      when x"3" =>   y <= x"1";
      when x"4" =>   y <= x"2";
      when x"5" =>   y <= x"8";
      when x"6" =>   y <= x"c";
      when x"7" =>   y <= x"f";
      when x"8" =>   y <= x"5";
      when x"9" =>   y <= x"d";
      when x"a" =>   y <= x"e";
      when x"b" =>   y <= x"0";
      when x"c" =>   y <= x"6";
      when x"d" =>   y <= x"9";
      when x"e" =>   y <= x"a";
      when others => y <= x"7";
    end case;
  end process sbox_decoder;
end;
