---------------------------------------------------------------------------
--
-- Copyright (c) 2016
-- Mitsubishi Electric Corporation
-- All rights reserved.
-- 
-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are
-- met:
-- 
-- 1. Redistributions of source code must retain the above copyright
-- notice, this list of conditions and the following disclaimer.
-- 
-- 2. Redistributions in binary form must reproduce the above copyright
-- notice, this list of conditions and the following disclaimer in the
-- documentation and/or other materials provided with the distribution.
-- 
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-- LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-- DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-- THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-- (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-- OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--
-- File Name: MA_roundfunc.vhd
-- Type: RTL 
-- Author: Takeshi SUGAWARA
-- Date: 2016/05/26
-- Version: 1.0
-- Abstract:
-- Modification History: 
--
---------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;  

entity MA_roundfunc is
  port(
    x:    in  std_logic_vector(255 downto 0);
    rcon: in  std_logic_vector(255 downto 0);    
    y:    out std_logic_vector(255 downto 0);
    Dout: out std_logic_vector(255 downto 0) 
    );
end MA_roundfunc;

architecture RTL of MA_roundfunc is
  component MA_S256 is
    port(
      x: in  std_logic_vector(255 downto 0);
      y: out std_logic_vector(255 downto 0)
      );
  end component;

  component MA_T256 is
    port(
      x: in  std_logic_vector(255 downto 0);
      y: out std_logic_vector(255 downto 0)
      );
  end component;

  component MA_M256 is
    port(
      x: in  std_logic_vector(255 downto 0);
      y: out std_logic_vector(255 downto 0)
      );
  end component;
  
  signal x_SN: std_logic_vector(255 downto 0);
  signal x_SM: std_logic_vector(255 downto 0);
  signal x_MC: std_logic_vector(255 downto 0);
begin
  S256: MA_S256 port map (x => x,    y => x_SN);
  T256: MA_T256 port map (x => x_SN, y => x_SM);
  M256: MA_M256 port map (x => x_SM, y => x_MC);
  y <= x_MC xor rcon;
  Dout <= x_SM;
end;
